--[=====[-------------- Modules --------------]=====]--
local states = require 'states'
local sprite = require 'sprite'
local lobby = require 'lobby'
local menu = require 'menu'

--[=====[-------------- Variables --------------]=====]--
local game = {}
local room

--[=====[-------------- Functions --------------]=====]--

function game:setroom(newroom)
    room = newroom
end


--[=====[-------------- Events --------------]=====]--

function game:load()
    local map = require 'map'
    map:load()
end


function game:when_activated()
    if self.initialize then
        self.initialize = false
        lobby:load()
        sprite:load()
        game:setroom('lobby')
    end
end


function game:update(dt)
    sprite:update(dt)
end


function game:draw()
    if room == 'lobby' then
        lobby:draw()
    end
end


function game:keypressed(key)
    if key == "escape" then
        menu:pausemenu()
    end
end

return game
