--[=====[-------------- Modules --------------]=====]--
local states = require 'states'

--love.window.setFullscreen(true, "desktop")

--[=====[-------------- Events --------------]=====]--
function love.load()
    states.introh = require 'introhandler'
    states.menu = require 'menu'
    states.info = require 'info'
    states.game = require 'game'

    for k, v in pairs(states) do
        if type(v) == "table" and v.load then v.load(args) end
    end
    states:activate(states.introh)
end

function love.update(dt)
    if states.active.update then states.active:update(dt) end
end

function love.draw()
    if states.active.draw then states.active:draw() end
end

function love.keypressed(...)
    if states.active.keypressed then states.active:keypressed(...) end
end
