--[=====[-------------- Modules --------------]=====]--
local bump = require 'bump'
local themap = require 'map'
local menu = require 'menu'

--[=====[-------------- Variables --------------]=====]--
local cols_len = 0
local world = bump.newWorld()
local allowmove = false
local sprite = {}
local debug = 1
local consoleBuffer = {}
local consoleBufferSize = 15

local rowIndex,columnIndex = 1,1
local player = {type=type({x=columnIndex, y=rowIndex}), x=100,y=100,w=20,h=20, speed = 80 }

local colbox = {x=100,y=100,w=100,h=100}
local blocks = {}



--[=====[-------------- Functions --------------]=====]--
for i=1,consoleBufferSize do consoleBuffer[i] = "" end
local function consolePrint(msg)
  table.remove(consoleBuffer,1)
  consoleBuffer[consoleBufferSize] = msg
end

local function drawBox(box, r,g,b)
  love.graphics.setColor(r,g,b,70)
  love.graphics.rectangle("fill", box.x, box.y, box.w, box.h)
  love.graphics.setColor(r,g,b)
  love.graphics.rectangle("line", box.x, box.y, box.w, box.h)
  love.graphics.setColor(255,255,255,100)
end

local function updatePlayer(dt)
  local dx, dy = 0, 0
  local speed = player.speed

  if debug == 1 then
      debug = 0
      print(world:countItems(), world:countCells())
  end
  
  if love.keyboard.isDown('right') then
    dx = speed * dt
  elseif love.keyboard.isDown('left') then
    dx = -speed * dt
  end
  if love.keyboard.isDown('down') then
    dy = speed * dt
  elseif love.keyboard.isDown('up') then
    dy = -speed * dt
  end
  
  if dx ~= 0 or dy ~= 0 then
    player.x, player.y, cols, cols_len = world:move(player, player.x + dx, player.y + dy)
    --player.x, player.y = actualX, actualY
    for i=1,cols_len do
        print(cols[i].other.type)
      
    if cols[i].other.type == ";" then
      EnableGame = 1
      if EnableGame == 1 then
        menu:allow()
        themap:load()
        --lobby:killself()
        lobbyexit = 1
      end
    end
    end
  end
end

local function drawPlayer()
  drawBox(player, 0, 255, 0)
  drawBox(colbox,10,10,10)
end

local function drawBlocks()
  for _,block in ipairs(blocks) do
    drawBox(block, 255,0,0)
  end
end

function sprite:load()
  EnableGame = 0
  lobbyexit = 0
  startgame = 0
  world:add(player, player.x, player.y, player.w, player.h)

end

function sprite:update(dt)
  updatePlayer(dt)
end

function sprite:draw()
  if EnableGame == 1 then
      startgame = 1
  end
  drawPlayer()
end


function sprite:keypressed(k)
  if k=="escape" then love.event.quit() end
end

--[=====[-------------- Global functions --------------]=====]--

function sprite:add_collision(item, x, y, w ,h)
    world:add(item, x, y, w, h)
end

function sprite:move_false()
    allowmove = false
end

function sprite:move_true()
    allowmove = true
end

function sprite:playery()
    return player.y
end

function sprite:playerx()
    return player.x
end

return sprite, lobbyexit, startgame



